#!/usr/bin/haserl --shell=/bin/sh
content-type: text/html

<% 
function getState
{
  file=`mktemp`
  dd if=/tmp/irDaemonInfo of=$file bs=4 count=1 &
  echo -e -n '\x00\x00\x00\x04' > /tmp/irDaemonCtrl
  for job in `jobs -p`; do
    wait $job
  done
  rv=`cat $file`
  rm $file
}

case "$FORM_action" in 
  "single")
    echo -e -n '\x00\x00\x00\x03' > /tmp/irDaemonCtrl
    ;; 
  "appleTv")
    echo -e -n '\x00\x00\x00\x01' > /tmp/irDaemonCtrl
    ;; 
  "sattelite")
    echo -e -n '\x00\x00\x00\x02' > /tmp/irDaemonCtrl
    ;; 
  "getState")
    getState
    echo -n $rv
    exit 0
    ;;
esac

%>

<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Button markup - jQuery Mobile Demos</title>
  <link rel="stylesheet" href="css/googleFont.css">
  <link rel="stylesheet" href="css/jquery.mobile-1.4.0.min.css">
  <script src="js/jquery-1.10.2.min.js"></script>
  <script src="js/jquery.mobile-1.4.0.min.js"></script>
  <style>
	#custom-border-radius .ui-btn-icon-notext.ui-corner-all {
		-webkit-border-radius: .3125em;
		border-radius: .3125em;
	}
  </style>
  <script>

    function updateState() {
      $.ajax({
        url: 'sat.sh',
	method: 'POST',
	data: {'action': 'getState' },
      }).done(function(data) {
        var cur=data;
        var selected="";
        switch(cur) {
          case "sat":
  	    selected="radio-choice-0c";
    	    break;
          case "aptv":
  	    selected="radio-choice-0b";
  	    break;
          case "unkw":
  	    break;
      	}

        $("input[name='action']").prop("checked", false);
        $("#" + selected).prop("checked", true).checkboxradio("refresh");
      	$.mobile.loading('hide');
      });

    }

    $(document).ready(function() {
      updateState();
      $("input[name='action']").click(function() {
        handleAjax();
      });
    });

    function handleAjax() {
      $.mobile.loading('show');
      $.ajax({
        url: 'sat.sh',
	method: 'POST',
	data: {'action': $("input[name='action']:checked").val() },
      }).done(function() {
	updateState();
      });
      $("input[name='action']").prop("checked", false).checkboxradio("refresh");
    }

  </script>
</head>
<body>
<h1>Switch TV source</h1>

<form name="selection" method="POST" action="<% echo -n $SCRIPT_NAME %>">
  <fieldset id="radiobuttons">
    <label>
        <input name="action" id="radio-choice-0a" type="radio" value='single' >Single switch
    </label>
    <label for="radio-choice-0b">Apple-TV</label>
    <label for="radio-choice-0c">Sattelite</label>
    <input name="action" id="radio-choice-0b" class="custom" type="radio" value='appleTv'>
    <input name="action" id="radio-choice-0c" class="custom" type="radio" value='sattelite'>
  </fieldset>
</form>

</html>
</body>


